package com.qs.service;

import java.io.UnsupportedEncodingException;

import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Vibrator;
import android.util.Log;
import android.zyapi.CommonApi;

public class ScanService extends Service {

	private final int MAX_RECV_BUF_SIZE = 512;
	private boolean isOpen = false;
	private static String pin_1 = "78";// һά
	private static String pin_2 = "86";// ά
	private byte[] recv;
	private int mComFd = -1;
	private String strRead;
	private final static int SHOW_RECV_DATA = 1;
	private static CommonApi mCommonApi;
	GreenOnReceiver greenOnReceiver;
	public static ServiceBeepManager beepManager;

	@Override
	public IBinder onBind(Intent intent) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		initGPIO();
		super.onCreate();
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// TODO Auto-generated method stub
		return super.onStartCommand(intent, flags, startId);
	}

	/**
	 * ߳
	 */
	private void readData() {
		new Thread() {
			public void run() {
				while (isOpen) {
					int ret = 0;
					byte[] buf = new byte[MAX_RECV_BUF_SIZE + 1];
					ret = mCommonApi.readComEx(mComFd, buf, MAX_RECV_BUF_SIZE,
							0, 0);
					if (ret <= 0) {
						Log.d("", "read failed!!!! ret:" + ret);
						try {
							sleep(1000);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						continue;
					}
					recv = new byte[ret];
					System.arraycopy(buf, 0, recv, 0, ret);
					try {
						strRead = new String(recv, "utf-8");
					} catch (UnsupportedEncodingException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					if (strRead != null) {
						Message msg = handler.obtainMessage(SHOW_RECV_DATA);
						msg.obj = strRead;
						msg.sendToTarget();
					}
				}
			}
		}.start();
	}
	AudioManager audio;
	boolean iscanScan=false;
	private Handler handler = new Handler() {
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case SHOW_RECV_DATA:
				String barCodeStr = (String) msg.obj;
				if (barCodeStr != "") {
					Intent intentBroadcast = new Intent();
					intentBroadcast.setAction("com.zkc.scancode");
					intentBroadcast.putExtra("code", barCodeStr.trim());
					Log.e("", "ɨϢ" + barCodeStr);
					sendBroadcast(intentBroadcast);
					sleepTime=0;
					isScanEnd=true;
					audio = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
					int RingerMode = audio.getRingerMode();
//					long [] pattern = {100,200};
//					Toast.makeText(getApplicationContext(), ""+RingerMode, Toast.LENGTH_LONG).show();
					//1,2,񶯼
					//0,ģʽ
					if(RingerMode!=0)
					{
						
						//
						if (beepManager != null
								&&RingerMode!=1
								) {
							beepManager.updatePrefs();
							beepManager.playBeepSoundAndVibrate();
						}
						//
//						vibrator.vibrate(pattern,-1); 
					}
				}
				break;
			}
		};
	};

	public static void open() {
		
		mCommonApi.setGpioDir(Integer.parseInt(pin_1), 0);
		mCommonApi.getGpioIn(Integer.parseInt(pin_1));
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		mCommonApi.setGpioDir(Integer.parseInt(pin_1), 1);
		mCommonApi.setGpioOut(Integer.parseInt(pin_1), 1);
	}

	public static void openScan() {
		mCommonApi.setGpioDir(Integer.parseInt(pin_1), 1);
		mCommonApi.setGpioOut(Integer.parseInt(pin_1), 1);
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		mCommonApi.setGpioDir(Integer.parseInt(pin_2), 0);
		mCommonApi.getGpioIn(Integer.parseInt(pin_2));
		
		try {
			Thread.sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		mCommonApi.setGpioDir(Integer.parseInt(pin_2), 1);
		mCommonApi.setGpioOut(Integer.parseInt(pin_2), 0);
		isScanEnd=false;
		sleepTime=0;
		myHandler.removeCallbacks(run);
		myHandler.post(run);
	}

	private void initGPIO() {
		// TODO Auto-generated method stub
		mCommonApi = new CommonApi();
		mComFd = mCommonApi.openCom("/dev/ttyMT1", 9600, 8, 'N', 1);
		if (mComFd > 0) {
			isOpen = true;
			readData();
		} else {
			isOpen = false;
		}
		open();

		greenOnReceiver = new GreenOnReceiver();

		IntentFilter filter = new IntentFilter();

		filter.addAction(Intent.ACTION_SCREEN_ON);

		filter.addAction(Intent.ACTION_SCREEN_OFF);
		
		filter.addAction(Intent.ACTION_USER_PRESENT);

		registerReceiver(greenOnReceiver, filter);
		
		beepManager=new ServiceBeepManager(this);
		beepManager.updatePrefs();
		
	    vibrator = (Vibrator)getSystemService(Context.VIBRATOR_SERVICE);  
		
	}
	
	Vibrator vibrator;

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		unregisterReceiver(greenOnReceiver);
		super.onDestroy();
	}

	class GreenOnReceiver extends BroadcastReceiver {
		@Override
		public void onReceive(Context context, Intent intent) {
			// TODO Auto-generated method stub
             //SCREEN_OFF
			if(intent.getAction().equals(Intent.ACTION_SCREEN_OFF)){
				
				mCommonApi.setGpioDir(Integer.parseInt(pin_2), 1);
				mCommonApi.setGpioOut(Integer.parseInt(pin_2), 0);
				
				mCommonApi.setGpioDir(Integer.parseInt(pin_1), 1);
				mCommonApi.setGpioOut(Integer.parseInt(pin_1), 0);
			}

		}

	}
	
	static boolean isScanEnd=false;
	static int sleepTime=0;
	static Handler myHandler=new Handler();
	static Runnable run=new Runnable() {
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if(sleepTime>=3){
				if(!isScanEnd){
					mCommonApi.setGpioDir(Integer.parseInt(pin_2), 1);
					mCommonApi.setGpioOut(Integer.parseInt(pin_2), 0);
					
					mCommonApi.setGpioDir(Integer.parseInt(pin_1), 1);
					mCommonApi.setGpioOut(Integer.parseInt(pin_1), 0);
				}
				myHandler.removeCallbacks(run);
				sleepTime=0;
			}else{
				sleepTime++;
				myHandler.postDelayed(run, 1000);
			}
		}
	};

}
